#!/usr/bin/perl -w
#
# Watches a modem and writes any CID information it recives to an shql table.
# Written by Lorance Stinson LoranceStinson AT gmail DOT com

use strict;
use IO::Handle;

# Edit these to match your setup.
my $modem = '/dev/modem'; # The modem Device.
my $initstr = 'ATE1V1Q0#CID=1'; # Set the modem to print CID info.
my $sttystr = '-parenb -parodd cs8 hupcl -cstopb cread clocal -crtscts -ignbrk -brkint -ignpar -parmrk -inpck -istrip -inlcr -igncr icrnl ixon -ixoff -iuclc -ixany -imaxbel opost -olcuc -ocrnl onlcr -onocr -onlret -ofill -ofdel nl0 cr0 tab0 bs0 vt0 ff0 isig icanon iexten -echo echoe echok -echonl -noflsh -xcase -tostop -echoprt echoctl echoke'; # Serial port init string.
my $db_dir = glob('~/shql/addr'); # The path to the SHQL database.

# Open tha database file.
open (DB,">>$db_dir/calls~") or die "Could not open DB file: $!";
autoflush DB 1;

# Open  and initialize the modem.
system("stty -F $modem $sttystr");
open (MODEMREAD,"<$modem") or die "Could not read from $modem: $!";
autoflush MODEMREAD 1;
open (MODEMWRITE,">$modem") or die "Could not write to $modem: $!";
autoflush MODEMWRITE 1;
print MODEMWRITE "$initstr\n";
close (MODEMWRITE);

# Wait for and log calls.
my %data = (); # The CID data received.
while (my $line = <MODEMREAD>) {
    chomp $line;
# DEBUG warn "$line\n";
    if ($line =~ /^(DATE|TIME|NMBR|NAME)\s*=\s*(.*)$/) {
        # Save the data.
        $data{$1} = $2;
        if ($1 eq 'NAME') {
            # Get the system time.
            my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);
            $year += 1900;
            $mon++;
            $mon = "0$mon" if length($mon) == 1;
            $mday = "0$mday" if length($mday) == 1;
            $hour = "0$hour" if length($hour) == 1;
            $min = "0$min" if length($min) == 1;
            $sec = "0$sec" if length($sec) == 1;
            my $systime = "$year-$mon-$mday $hour:$min:$sec";
            # Write the data to the database.
# DEBUG     warn "$data{'NMBR'}\t$data{'NAME'}\t$data{'DATE'}\t$data{'TIME'}\t$systime\n";
            print DB "$data{'NMBR'}\t$data{'NAME'}\t$data{'DATE'}\t$data{'TIME'}\t$systime\n";
        }
    }
}
close (MODEMREAD);
close (DB);
