-- Definition of the table calls
create table calls (
	cnumber	char(10),
	cname	char(15),
	cdate	int(4),
	ctime	int(4),
	systime	char(19)
);

-- Definition of the table cid
create table cid (
	name	char(20),
	number	char(20),
	note	char(15)
);

-- Definition of the table people
create table people (
	name	char(20),
	email	char(30),
	altemail	char(30),
	home	char(15),
	cell	char(15),
	work	char(15),
	addr	char(30),
	note	char(15)
);

-- Data for table calls
insert into calls values ("1111111111","UNKNOWN NAME","0101","1327","2006-01-01 13:27:47");
insert into calls values ("2222222222","FRIEND","0102","1458","2006-01-02 14:58:35");
insert into calls values ("3333333333","UNKNOWN NAME","0102","1848","2006-01-02 18:48:41");
insert into calls values ("4444444444","WORK LINE 1","0103","1903","2006-01-03 19:03:54");
insert into calls values ("5555555555","WORK LINE 2","0103","0933","2006-01-03 09:33:27");
insert into calls values ("2222222222","FRIEND","0104","0942","2006-01-04 09:42:54");
insert into calls values ("6666666666","UNKNOWN NAME","0104","1105","2006-01-04 11:05:39");

-- Data for table cid
insert into cid values ("Good Friend","2222222222","Home");
insert into cid values ("Good Friend","3333333333","Cell");
insert into cid values ("Work","4444444444","Line 1");
insert into cid values ("Work","5555555555","Line 2");
insert into cid values ("Work","7777777777","Fax");

-- Data for table people
insert into people values ("Good Friend","friend@home.tld","friend@work.tld","(222) 222-2222","(333) 333-3333","(888) 888-8888","","");
insert into people values ("Work","staff@work.tld","","","","(444) 444-4444","","");

-- Definition of the view phone
create view phone as select name home cell work from people where home or cell or work order by name;

-- Definition of the view email
create view email as select name email altemail from people where email or altemail order by name;

-- Definition of the view known
create view known as select name cnumber cdate ctime systime note from cid calls where number = cnumber;

-- Definition of the view unknown
create view unknown as select * from calls where cnumber not in select number from cid;

